%Asteroid_Finder
%
%
%
%
%BH

% Define Global Parameters

%List file name of the field
% One name file per line
listFile='Antenor_list.txt' ;

%Threshold for detect star
umbral=0.65;

%Disk parameters
radio=2;
minArea=11; %minmum area of the disk
maxArea=100; %maximarea of the disk


%Read List
[nameF,NF]=readList(listFile);

%Read Datacube
[Dcube,newNF]=Read_DataCube_fits(nameF,NF);

%% Collect detected Point
% thePoint{i, 1} Object  Area
% thePoint{i, 2} Object  Centroid
% thePoint{i, 3} Object  Box (x,y) sup left point, Dx, Dy
% thePoint{i, 4}  Number of found Points
% thePoint{i,5} num of matched

global thePoint

thePoint=cell(newNF,5);
debug=0;

for nimg=1:newNF
   
    [thePoint{nimg,1},thePoint{nimg,2},thePoint{nimg,3},thePoint{nimg,4}]=...
        findPoints(Dcube(:,:,nimg),...
        umbral,radio,minArea,maxArea,nameF{1}(nimg),debug);
    if debug 
        pause(1);
    end
end

% Initialize num of matched
for nimg=1:newNF
    thePoint{nimg,5}(1:thePoint{nimg,4},1)=-1;
end


%% 
% minum search Radius 
dim=size(Dcube);
sizeX=dim(2); % The columns is axis X
sizeY=dim(1); % The row is axis Y

searchRadius=sizeX;
for nimg=1:newNF
    old=minHalfDistance(thePoint{nimg,2},[sizeX,sizeY]);
    if old < searchRadius
        searchRadius=old;
    end
end
% search all points in the first image
refImg=1; % first frame
matchP=cell(thePoint{refImg,4},1);
 for p=1:thePoint{refImg,4}
          matchP{p,1}=matchPoint(p,refImg,newNF,searchRadius);
 end

  % Common point found in all image
  ncomm=0;
  commP=zeros(thePoint{refImg,4},1);
  c=newNF-2;
   for p=1:thePoint{refImg,4}
       if (thePoint{refImg,5}(p) == c)
           ncomm=ncomm+1;
           commP(ncomm)=p;
       end
   end
%  vecY(1)=thePoint{1,2}(1,2);
%  for i=1:201;  img=matchP{1,1}(i,1); point=matchP{1,1}(i,2); vecY(i+1)=thePoint{img,2}(point,2); end
%  plot (vecY)

fprintf('I found: %d common  points \n', ncomm);
for p=1:ncomm
    fprintf('P[%d]: ( %4.2f, %4.2f ) \n', ...
        commP(p),...
        thePoint{refImg,2}(commP(p),1), ...
         thePoint{refImg,2}(commP(p),2))
end
fprintf('\n');

debug=0;
if debug
       objBox=zeros(ncomm,4);
       for p=1:ncomm
           objBox(p,:)=thePoint{refImg,3}(commP(p),:);
       end
       delta=4;
        bboxOut_2(:,1)=objBox(:,1)-delta;
        bboxOut_2(:,2)=objBox(:,2)-delta;
        bboxOut_2(:,3)=objBox(:,3)+2*delta;
        bboxOut_2(:,4)=objBox(:,4)+2*delta;
        M=log(Dcube(:,:,refImg));
        fact=1/(max(M(:))-min(M(:)));
        themin=min(M(:));
        MNor=(M - themin).*fact;
        imgShape= insertShape(MNor,'rectangle',bboxOut_2,'Linewidth',2,'Color',[255 0 0]);
        imshow(imgShape);

end
%% Compute the Rotation and Translation transform
% RefB=RA+t

% Minimum 2 points is better 3 or more
commP2=[1;2;7;8]; %for ths aproach P1,P2,P7,P8
ncomm2=4;
%trasformR(i,1)= R (rotation)
%trasformR(i,2)= t (translation)
trasformR=cell(newNF,2);

%RefPoint corresponds to points in 1st image
for k=1:ncomm2
    refB(k,:)=thePoint{1,2}(commP2(k),:);
end
trasformR{1,1}=[1,0;0,1];
trasformR{1,2}=[0;0];

for  nimg=2:newNF
    for k=1:ncomm2
         rowM=find(matchP{commP2(k)}(:,1)==nimg);
         pImg2=matchP{commP2(k)}(rowM,2);
          A(k,:)=thePoint{nimg,2}(pImg2,:);
    end
    [trasformR{nimg,1}, trasformR{nimg,2}]=...
        rigidTransform2D(A, refB);
end

%

%A(1,:)=thePoint{1,2}(commP(1),:)
%A(2,:)=thePoint{1,2}(commP(2),:)
% A(3,:)=thePoint{1,2}(commP(3),:)
% Img2=190;
% rowM=find(matchP{commP(1)}(:,1)==Img2)
%  pImg2=matchP{commP(1)}(rowM,2)
% B(1,:)=thePoint{Img2,2}(pImg2,:)
%rowM=find(matchP{commP(2)}(:,1)==Img2)
% pImg2=matchP{commP(2)}(rowM,2)
% B(2,:)=thePoint{Img2,2}(pImg2,:)
% rowM=find(matchP{commP(3)}(:,1)==Img2)
% pImg2=matchP{commP(3)}(rowM,2)
% B(3,:)=thePoint{Img2,2}(pImg2,:)
%%  Aligne Images

AllignCube=zeros(size(Dcube));
AllignCube(:,:,1)=Dcube(:,:,1);
minCoor=zeros(newNF,2);
maxCoor=zeros(newNF,2);
minCoor(1,1)=1;
minCoor(1,2)=1;
maxCoor(1,1)=sizeX;
maxCoor(1,2)=sizeY;
parfor nimg=2:newNF
    [AllignCube(:,:,nimg), minCoor(nimg,:),maxCoor(nimg,:)] = ...
        doAlling( Dcube(:,:,nimg) , [sizeX sizeY] ,trasformR{nimg,1},trasformR{nimg,2});
end

if debug
    A=Dcube(:,:,refImg);
    A=log(A);
    fact=1/(max(A(:))-min(A(:)));  themin=min(A(:)); A=(A-themin).*fact;
    objBox=zeros(ncomm,4);  
     for p=1:ncomm
           objBox(p,:)=thePoint{refImg,3}(commP(p),:);
     end
    delta=4;
    bboxOut_2(:,1)=objBox(:,1)-delta;
    bboxOut_2(:,2)=objBox(:,2)-delta;
    bboxOut_2(:,3)=objBox(:,3)+2*delta;
    bboxOut_2(:,4)=objBox(:,4)+2*delta;
        
    ishapeA= insertShape(MNor,'rectangle',bboxOut_2,'Linewidth',2,'Color',[255 0 0]);
    %imshow(imgShape);
    % Cual quieres ver
    cual=202;
    B=Dcube(:,:,cual);
    B=log(B);
    fact=1/(max(B(:))-min(B(:)));  themin=min(B(:)); B=(B-themin).*fact;
    figure(1)
    imshowpair(ishapeA,B,'montage');
    s=sprintf('Left Reference Image [ %d ]    Rigth Image  to be alligned [ %d]', refImg,cual);
    title(s);
    
    pause(2);
    
    figure (2)
    imshowpair(ishapeA,B,'blend','Scaling','joint');
    title('Joint A-ref  and B');
    pause(1);
    
    C=AllignCube(:,:,cual);
    C=log(C);
    fact=1/(max(C(:))-min(C(:)));  themin=min(C(:)); C=(C-themin).*fact;
    figure (3)
    imshowpair(ishapeA,C,'blend','Scaling','joint');
    title('Joint A and B-alligned ');
    pause(1);
    
    [DofM,M]=diffOfMedian(Dcube);
    M=log(M);
    fact=1/(max(M(:))-min(M(:))); themin=min(M(:)); M=(M-themin).*fact;
    
     [DofM2,M2]=diffOfMedian(AllignCube);
    M2=log(M2);
    fact=1/(max(M2(:))-min(M2(:))); themin=min(M2(:)); M2=(M2-themin).*fact;
     s=sprintf('Left Median of the  Data Cube  Rigth Median of the Alligned Data Cube');
     
     figure(4);
      imshowpair(M,M2,'montage');
      title(s);
      pause(1);
    
    
end

%A=Dcube(:,:,1);
%A=log(A);
% fact=1/(max(A(:))-min(A(:)));  themin=min(A(:)); A=(A-themin).*fact;
% imshowpair(A,C,'blend','Scaling','joint');
%imshowpair(A,B,'montage')

%% Compute  usuable Area and enhanced  the frames according the sky level 

uArea=zeros(2,2); % row1  min';  row 2  max; (x,y) coord

uArea(1,1)=max(minCoor(:,1));
uArea(1,2)=max(minCoor(:,2));
uArea(2,1)=min(maxCoor(:,1));
uArea(2,2)=min(maxCoor(:,2));

newCube=AllignCube(uArea(1,2):uArea(2,2), uArea(1,1):uArea(2,1),:);

% I need 3 region box,  I suggest to use Mediina Image and ds9 regions
%tools. Of course you can use only one  region
fileMedian='Median_Cube.fits';
[~,Median_newCube]=diffOfMedian(newCube); 
fitswrite(Median_newCube,fileMedian);
% Use ds9 to slectect the regions and save it using IRAF pro format
skRegFile='SkyRegions_02.reg';
theReg=readRegionDs9(skRegFile);

%Otherwise write manualy the Region Description
% theReg: [Xc,Yc,Widht,Hight]

[skCube,skMedian,skStd,skMean]=skyAdjust2(newCube,theReg);

%% Differences over the median may be works better than raw Image

facBg= sqrt(2);  %Factor of the background to detect stars
bgFlag=1; % replace the minum valus with the background
radiusOfD=5; % Radius of dilation image
debug=0;
skCube_m=DofMbg(skCube,theReg, facBg,bgFlag, radiusOfD, debug);

%[DofM_sk,Median_sk]=diffOfMedian(skCube);
%fitswrite(Median_sk,'Median_sk.fits');
%[theMask, centroidMask, areaMask, ~]=maskMedian(Median_sk,theReg,sqrt(2),2);
%[theMask, centroidMask, areaMask, ~,kk]=maskMedian(Median_sk,theReg,sqrt(2),1);
%[~,skMedian_001,~,~]=skyAdjust2(skCube(:,:,1),theReg);
%fitswrite(skCube(:,:,1), 'Cube_sk_001.fits');
%skCube_001_m=skCube(:,:,1);
%skCube_001_m(theMask)=skMedian_001;
%fitswrite(skCube_001_m, 'Cube_sk_001.m.fits');
%skCube_001_m(skCube_001_m < skMedian_001)=skMedian_001;
%fitswrite(skCube_001_m, 'Cube_sk_001.m2.fits');
%% Velocity V=(v_x,v_y)

 
[SS,minC,maxC,theV]=vpixSumShift(skCube_m,[-0.7,-0.4,0.02],[0.6,0.9,0.02]);
[SS2,usuArea2,theV2]=vpixSumShift2(skCube_m,[-0.7,-0.4,0.1],[0.6,0.9,0.1]);

%[Antenor01_sk, m1, m2] = sumShift(skCube,[-0.536,0.778]);
%[A2007TG140, m1, m2] = sumShift(skCube(:,:,1:68),[0.519,1.785]);
%fitswrite(A2007TG140,'B2007sk-001-068.fits');
%
%
%>> [A2007TG140, m1, m2] = sumShift(skCube(:,:,1:68),[0.519,1.785]);
%>> fitswrite(A2007TG140,'B2007sk-001-068.fits');
%>> [A2007TG140, m1, m2] = sumShift(skCube(:,:,69:135),[0.519,1.785]);
%>> fitswrite(A2007TG140,'B2007sk-069-0135.fits');
%>> [A2007TG140, m1, m2] = sumShift(skCube(:,:,136:202),[0.519,1.785]);
%>> fitswrite(A2007TG140,'B2007sk-136-202.fits');
%>> [MofD,M]=diffOfMedian(skCube);
%>> fitswrite(M,'MdianSK.fits');
%>> fitswrite(M(:,:,20),'DofMSK_020.fits');


%% find Asteroid

 img=1; fstd=2.5; r=4;minBlob=r^2*4; maxBlob=40*40;d=1;
 detectAsteroide(SS(:,:,img),minC(:,img),maxC(:,img),theV(:,img),fstd,r,minBlob,maxBlob,d);

img=1; fstd=2.5; r=4;minBlob=r^2*4; maxBlob=20*20;d=1;



