%%
%Dtection  Asteoride
%This process does not  substract the median of the data cube over itself

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube and his header info\n');
fprintf('          The list of file must be include the start patches\n');
tic  

%listFile='P21lkhv_list_AL.txt';
%listFile='P21ltbf_list_ALSMP.txt';
listFile='S475665_list_ALSMP.txt';

[nameF,NF]=readList(listFile);
DATEOBS=cell(NF,1);
EXPTIME=cell(NF,1);
JD=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);
for nimg=1:NF
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    JD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(1);
     minCoor2(nimg,2)=theVal(3);
     maxCoor2(nimg,1)=theVal(2);
     maxCoor2(nimg,2)=theVal(4);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc
%%
% Clear higth values on data (above  ~5 times the std over the mean)
tic
ntimes=8;
fprintf('\nStep 2: Clear higth values on data above [ %d ] times the STD over the mean\n',ntimes);

Dcube2=zeros(size(Dcube),'like',Dcube);
parfor nimg=1:NF
     Dcube2(:,:,nimg)=asteroid_level(Dcube(:,:,nimg),ntimes);
end
toc

%% 
% Detect asteroids 

fprintf('\n Step 3: Mesh of Velocities, sum&shift and detect Asteoide\n');

%Create  mesh velocities
xRange=[-.4,.8,0.05];
%xRange=[0.0,1.,0.2];
%xRange=[1.5,2,0.1];


yRange=[0.5 ,1.9,0.05];
%yRange=[1.0 ,2.0,0.2];
%yRange=[-1.0 ,-0.5,0.1];


fprintf('Step3: Detect asteroids\n');
fprintf('   X range: [%+5.3f,%+5.3f,%+5.3f]\n',xRange);
fprintf('   Y range: [%+5.3f,%+5.3f,%+5.3f]\n',yRange);
tic

theVel=try_velocities(xRange,yRange);
ntries=length(theVel);
fprintf('   Number of tries: %d\n',ntries*3);

% Sensibilty of the detector

eccentricity=0.4;
radius=2.4; % minimum search radius 


% factorSTD is a important parameter.
%If an asteroid exists, must be see like a star (2.5 Sigma) 
%over the median. When then the correct position occure
  %the asteroide may be twise like star (5 Sigma)

factorSTD=5.0; % how many times the standar deviation, above te mean,  
                    %is considered a interest region 

fprintf('   Eccentricity: %3.3f\n',eccentricity);
fprintf('   Minimum Radius: %d\n',radius);
fprintf('   Threshold (Factor*STD over mean): %5.3f\n',factorSTD);

Ovel=cell(ntries,1); %Velocity
OminC=cell(ntries,1); %min coordinate (x,y)
OmaxC=cell(ntries,1);  % max coordinate (x,y)
Ocenter=cell(ntries,1); % Centroide 
%Ooffset=cell(ntries,1); % Offset by rigid trasnformations  and shifted image
Oecc=cell(ntries,1); % Eccentricity
Oarea=cell(ntries,1); % Area
Obox=cell(ntries,1); % Box 


% Is better analyze the only usuable area 
flagUArea=1;
%flagUArea=0;
Dcube3=Dcube2(minCoor2(1,2):maxCoor2(1,2) ,  minCoor2(1,1):maxCoor2(1,1) ,:);
%Dcube3=Dcube2;

debug=0;
%Save the velocities of  the  interest regions, if they are greater than
%one.
num_vel=0;
resume_vel=cell(ntries,3);



t0={'Begin','Middle','End'}; 
for tries=1:length(theVel)
 for j=1:3
  Ovel{tries}=theVel(tries,:);
  [A,OminC{tries},OmaxC{tries}]=sumShift_Gaps(Dcube3, theVel(tries,:),JD,...
      t0(j),flagUArea);
  [Ocenter{tries},Oecc{tries},Oarea{tries},Obox{tries}]=...
     detectAsteroide_runV2(A, factorSTD, radius, eccentricity);

  nn=numel(Oecc{tries});
  if (nn == 1 )
          if Oecc{tries} == -1
              nn=0;
          end
  end
   if debug
       fprintf('%4d.- Vxy[ %+6.4f, %+6.4f] [t0=%s ] candidates: %d\n', ...
           tries,theVel(tries,:),char(t0(j)), nn);
   end 
   if (nn > 0)
       num_vel=num_vel+1;
       resume_vel{num_vel,1}=theVel(tries,1);
       resume_vel{num_vel,2}=theVel(tries,2);
       resume_vel{num_vel,3}=nn;
       fprintf('%4d.- Vxy[ %+6.4f, %+6.4f] [t0=%s ] candidates: %d\n', ...
           tries,theVel(tries,:),char(t0(j)), nn);
       break;
   end
 end
end
toc
%%
%
% Print reults
% Vel, Usuable Area image flag, Absolut Center (x,y), Relative Center (x,y), Area, Eccentricity, Box
% (x_lelt,y_uper, width, high), U Area1 (X_min, Y_min, Xmax, Y_max), Shift
% UArea2 (X_min, Y_min, Xmax, Y_max)

fprintf('\n Step 4: Write results\n');
tic

fileDetect='S475665_Detect.txt'; %name of report
fileDetectR='S475665_DetectResume.txt'; %name of resumed report

fileID = fopen(fileDetect,'w');
fileIDR = fopen(fileDetectR,'w');
fprintf(fileID,'# Flie List: %s\n',listFile);
fprintf(fileIDR,'# Flie List: %s\n',listFile);
fprintf(fileID,'# Date: %s\n',datestr(now));
fprintf(fileIDR,'# Date: %s\n',datestr(now));
fprintf(fileID,'# Number of images processed: %d\n', NF);
fprintf(fileIDR,'# Number of images processed: %d\n', NF);
fprintf(fileID,'# Sykes removed above ntimes*STD: %d\n',ntimes);
fprintf(fileIDR,'# Sykes removed above ntimes*STD: %d\n',ntimes);
fprintf(fileID,'# X range: [%+5.3f,%+5.3f,%+5.3f]\n',xRange);
fprintf(fileIDR,'# X range: [%+5.3f,%+5.3f,%+5.3f]\n',xRange);
fprintf(fileID,'# Y range: [%+5.3f,%+5.3f,%+5.3f]\n',yRange);
fprintf(fileIDR,'# Y range: [%+5.3f,%+5.3f,%+5.3f]\n',yRange);
fprintf(fileID,'# Number of tries: %d\n',ntries);
fprintf(fileIDR,'# Number of tries: %d\n',ntries);
fprintf(fileID,'# Eccentricity: %3.3f\n',eccentricity);
fprintf(fileIDR,'# Eccentricity: %3.3f\n',eccentricity);
fprintf(fileID,'# Minimum Radius: %d\n',radius);
fprintf(fileIDR,'# Minimum Radius: %d\n',radius);
fprintf(fileID,'# Threshold (Fctor*STD over mean): %5.3f\n',factorSTD);
fprintf(fileIDR,'# Threshold (Fctor*STD over mean): %5.3f\n',factorSTD);
fprintf(fileID,'# Usable Area [0=full image|1: Effective area]: %d\n',flagUArea);
fprintf(fileIDR,'# Usable Area [0=full image|1: Effective area]: %d\n',flagUArea);
fprintf(fileID,'# Frame Velocities | Absolute Position | Relative Position |');
fprintf(fileID,' Area |Eccentricity|  Box definition relatve position \n');
fprintf(fileID,'#   Vx  ,   Vy     | X_center,Y_center |X_center,Y_center  |');
fprintf(fileID,'      |            | X_left, Y_upper, Width, Hight \n');

fprintf(fileIDR,'# Frame Velocities |  Candidates\n');
fprintf(fileIDR,'#   Vx  ,   Vy    |       No\n');


 dx1=minCoor2(1,1)-1;
 dy1=minCoor2(1,2)-1;
 fprintf('Frame V_x, Frame V_y, Absolute Pos X_ca, Y_ca, Relative Pos X_cr, Y_cr, Area, Ecc, Box  X_left, Y_upper, width, hight\n');
for  tries=1:length(theVel)
    np=size(Ocenter{tries}); 
    
    if (sum(np)>2)
        dx2=OminC{tries}(1)-1;
        dy2=OminC{tries}(2)-1;
        for p=1:np(1)
            absCoorX=Ocenter{tries}(p,1)+dx1+dx2;
            absCoorY=Ocenter{tries}(p,2)+dy1+dy2;
            fprintf('%+f, %+f',Ovel{tries});  %Velocity
            %fprintf(', %d',flagUArea); % Usuable Area Image flag
            fprintf(', %f, %f',absCoorX,absCoorY); % Center Absolute (x,y)
            fprintf(', %f, %f',Ocenter{tries}(p,:)); % Center Relative (x,y)
            fprintf(', %f',Oarea{tries}(p)); % Area
            fprintf(', %f',Oecc{tries}(p)); %  Eccentricity
            fprintf(', %d, %d, %d, %d',Obox{tries}(p,:)); %  Box
            fprintf('\n'); %End line
            
            fprintf(fileID,'%+f, %+f',Ovel{tries});
            fprintf(fileID,', %f, %f',absCoorX,absCoorY);
            fprintf(fileID,', %f, %f',Ocenter{tries}(p,:));
            fprintf(fileID,', %f',Oarea{tries}(p));
            fprintf(fileID,', %f',Oecc{tries}(p));
            fprintf(fileID,', %d, %d, %d, %d',Obox{tries}(p,:));
            fprintf(fileID,'\n');
        end    
    end
        
end

for  tries=1:num_vel
    fprintf(fileIDR,'%+f, %+f, %d\n',  resume_vel{tries,:});
end
	
fclose(fileID);
fclose(fileIDR);

toc
