%%
%  Master Asteroide  Finder
%  Data Cube Alignment
%
%

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  

%listFile='C60DT42_list.txt'; % Compleate area
%listFile='P21lkhv_list.txt';
%listFile='P21ltbf_list.txt';
%listFile='P21IDy8_list.txt';
listFile='475665_list.txt'; 

[nameF,NF]=readList(listFile);

fprintf('Filename: %s\n', listFile);
%Read header. Its depend of the interest fits kerwords 
%tant you need in the experiment

DATEOBS=cell(NF,1);
EXPTIME=cell(NF,1);
JD=cell(NF,1);
for nimg=1:NF
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
    JD{nimg}=readHDR(nameF{1}(nimg,:),'JD','%d');
    NAXIS1=readHDR(nameF{1}(nimg,:),'NAXIS1','%d');
    NAXIS2=readHDR(nameF{1}(nimg,:),'NAXIS2','%d');
    if (nimg ==1)
        oNAXIS1=NAXIS1;
        oNAXIS2=NAXIS2;
    end
     if (oNAXIS1 ~=  NAXIS1)
         fprintf('Error: The file [%d]: %s has different NAXIS1[%d], I expect [%d]', ...
             nimg,char(nameF{1}(nimg,:)),NAXIS1,oNAXIS1);
         return;
     end
     if (oNAXIS2 ~=  NAXIS2)
         fprintf('Error: The file [%d]: %s has different NAXIS2[%d], I expect [%d]', ...
             nimg,char(nameF{1}(nimg,:)),NAXIS2,oNAXIS2);
         return;
     end
end

bitPix=readHDR(nameF{1}(1,:),'BITPIX','%s');

if  bitPix==16
    for nimg=1:NF
      Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
    end
else
    for nimg=1:NF
       Dcube(:,:,nimg)=fitsread( char(nameF{1}(nimg,:)) ) ;
    end
end

% Mmh.. This image has noise or strange pixel values (negatives) in the 
% column [513:end] and is not  posible to align the image
% In this case I see that te science data area is [1:512,1:512] 
% I used de  cropMatrix functions, use help cropMatrix for more info, to
% read the efective area
% Please comment the next lines when the original files does not have 
% problem to alingning
for nimg=1:NF
    Dcube_n(:,:,nimg)=cropMatrix(Dcube(:,:,nimg),'[1:512,1:512]');
end
clear Dcube; % Delete the otiginal cube
Dcube=Dcube_n; % Restore the new area
clear Dcube_n; % Release memory
% end comment 


toc
    
    
%%
% Collect detected Point
fprintf('\n#####################\n');
fprintf('Step 2: Searching  prominent stars \n');
tic

debug=1;
radio=3; %minimum blob radio to be detected
minArea=round(radio^2*pi); %minimum area of the disk
maxArea=500; %maxima area of the disk
global thePoint

%Threshold for detect star
umbral=0.4;             % Pixels above the umbral
desvUmbral=0.35;    % Deviation of Umbral for best Points search process
bestPoints=7;               % desirable point number
minPoints=3;                % minumum  point number
maxPoints=14;             % maximim  point number

thePoint=cell(NF,5);
% Only for use paralezation
theArea=cell(NF,1);
theCenter=cell(NF,1);
theBox=cell(NF,1);
theNP=cell(NF,1);
theTR=cell(NF,1);

% for display images  put debug=3, and substitute parfor to for. 
% display images don't works over parallel enviroment
parfor nimg=1:NF
   
    [theArea{nimg},theCenter{nimg},theBox{nimg},theNP{nimg},theTR{nimg}]=...
        findPointsDDoti(single(Dcube(:,:,nimg)),...
        umbral, desvUmbral, radio,minArea,maxArea, ...
        bestPoints,minPoints, maxPoints, nameF{1}(nimg),debug);
end


% only collect  points with distance > 20% of his median,
%  for each  individual image. I preserve the one with the largest area
for nimg=1:NF
   D=pdist(theCenter{nimg});
   medianD=median(D)*0.20; 
   mD=squareform(D);
   imgNP=theNP{nimg};
   countDel=0;
   for i=1:theNP{nimg}
       for j=i+1:theNP{nimg}
          if(  mD(i,j) < medianD)
              imgNP=imgNP-1;
              theArea{nimg}(j-countDel)=[];
              theCenter{nimg}(j-countDel,:)=[];
              theBox{nimg}(j-countDel,:)=[];
              countDel=countDel+1;
          end
       end
   end
   theNP{nimg}=imgNP;
end


%Join the parallel variables in only  one
thePoint(:,1)=theArea;
thePoint(:,2)=theCenter;
thePoint(:,3)=theBox;
thePoint(:,4)=theNP;


toc
%% 
% Search common points
% minum search Radius 

fprintf('\n##################################\n');
fprintf('Step 3: Searching common start \n');
tic  

for nimg=1:NF
    thePoint{nimg,5}(1:thePoint{nimg,4},1)=-1;
end

dim=size(Dcube);
sizeX=dim(2); % The columns is axis X
sizeY=dim(1); % The row is axis Y

searchRadius=sizeX;
facDistace=0.9;
imgDistMin=0;

for nimg=1:NF
   old=(min(pdist(thePoint{nimg,2})))*facDistace;
   if old < searchRadius
       searchRadius=old;
       imgDistMin=nimg;
   end
end

% search all points in the first image
refImg=1; % first frame
matchP=cell(thePoint{refImg,4},1);
 for p=1:thePoint{refImg,4}
          matchP{p,1}=matchPoint(p,refImg,NF,searchRadius);
 end

  % Common point found in all image
  ncomm=0;
  commP=zeros(thePoint{refImg,4},1);
  c=NF-2;
   for p=1:thePoint{refImg,4}
       if (thePoint{refImg,5}(p) == c)
           ncomm=ncomm+1;
           commP(ncomm)=p;
       end
   end
%  vecY(1)=thePoint{1,2}(1,2);
%  for i=1:201;  img=matchP{1,1}(i,1); point=matchP{1,1}(i,2); vecY(i+1)=thePoint{img,2}(point,2); end
%  plot (vecY)

fprintf('I found: %d common  points \n', ncomm);
for p=1:ncomm
    fprintf('%3d: P[%d]: ( %4.2f, %4.2f ) \n', ...
        p, ...
        commP(p),...
        thePoint{refImg,2}(commP(p),1), ...
         thePoint{refImg,2}(commP(p),2))
end
fprintf('\n');
toc

debug=1;
if debug
       objBox=zeros(ncomm,4);
       for p=1:ncomm
           objBox(p,:)=thePoint{refImg,3}(commP(p),:);
	   objCentroid(p,:)=thePoint{refImg,2}(commP(p),:);
       end
       delta=4;
       bboxOut_2(:,1)=objBox(:,1)-delta;
       bboxOut_2(:,2)=objBox(:,2)-delta;
       bboxOut_2(:,3)=objBox(:,3)+2*delta;
       bboxOut_2(:,4)=objBox(:,4)+2*delta;
       M=log(single(Dcube(:,:,refImg)));
       fact=1/(max(M(:))-min(M(:)));
       themin=min(M(:));
       MNor=(M - themin).*fact;
       imgShape= insertShape(MNor,'rectangle',bboxOut_2,'Linewidth',2,'Color',[255 0 0]);
       imshow(imgShape);

       delta2=delta+3;
       textPos=round(objCentroid+delta2);
       imgSize=size(Dcube(:,:,refImg));
       xmax=imgSize(2);
       ymax=imgSize(1);
       for i=1:ncomm
            if(textPos(i,1) > (xmax -50))
                 textPos(i,1)=round(objCentroid(i,1)-(2*delta2));
            end
            if(textPos(i,2) > (ymax -20))
              textPos(i,2)=round(objCentroid(i,2)-(2*delta2));
            end
       end
           
       text_objstr = cell(ncomm,1);
       for i=1:ncomm
          text_objstr{i}=['P[' num2str(i,'%d') ']' ];
       end
   
       imgShapeText=insertText(imgShape,  textPos, text_objstr, ...
            'TextColor','yellow','FontSize',16,'BoxColor' ,[1 1 1],...
            'BoxOpacity',0);
       imshow(imgShapeText);
       t=sprintf('%s ',char(nameF{1}(refImg)));
       t2=sprintf('Points found: %d',ncomm);
       title([t,t2],'Interpreter', 'none');

       clear M MNor 
end


%% Compute the Rotation and Translation transform
% RefB=RA+t

fprintf('\n##################################\n');
fprintf('Step 3: Compute the Rigid Transform \n');
tic  

%All points
commP2=commP(1:ncomm);
ncomm2=ncomm;
transformR=cell(NF,2);

%RefPoint corresponds to points in 1st image
for k=1:ncomm2
    refB(k,:)=thePoint{1,2}(commP2(k),:);
end
transformR{1,1}=[1,0;0,1];
transformR{1,2}=[0;0];

for  nimg=2:NF
    for k=1:ncomm2
         rowM=find(matchP{commP2(k)}(:,1)==nimg);
         pImg2=matchP{commP2(k)}(rowM,2);
          A(k,:)=thePoint{nimg,2}(pImg2,:);
    end
    [transformR{nimg,1}, transformR{nimg,2}]=...
        rigidTransform2D(A, refB);
end

toc

%%  Align Images
fprintf('\n#####################\n');
fprintf('Step 4: Aling images \n');
tic

AlignCube=zeros(size(Dcube),'like',Dcube);
AlignCube(:,:,1)=Dcube(:,:,1);
 [sizeY, sizeX,~]=size(Dcube);
parfor nimg=1:NF
        [AlignCube(:,:,nimg), minCoor(nimg,:),maxCoor(nimg,:)] = ...
        doAlign02( Dcube(:,:,nimg) , [sizeX sizeY] ,transformR{nimg,1},transformR{nimg,2});
end

toc
%%
% Write the  alligned Data.
fprintf('\n#####################\n');
fprintf('Step 5: Write data aligned data cube  process\n');
tic



uArea=zeros(2,2); % row1  min';  row 2  max; (x,y) coord

uArea(1,1)=max(minCoor(:,1));
uArea(1,2)=max(minCoor(:,2));
uArea(2,1)=min(maxCoor(:,1));
uArea(2,2)=min(maxCoor(:,2));

% Ya me canse de escribir el path, voy a quedarme solo
% con el nombre del archivo...
%
%

outDir='./';
[newNameFile,onlyNewName] = changeNames(nameF{1},'AL.fits',outDir);
refImageName=changeNames(nameF{1}(refImg),'.fits','');
%newNameFile= strrep(nameF{1},'.fits','AL.fits');
% remove the directory  of the original datacebe
%This process must be manual
%onlyNewName=strrep(newNameFile,'NewAst/P21lkhv/','');
%onlyNewName=strrep(newNameFile,'NewAst/P21ltbf/','');
% change de original directory to working directorory "./"
%newNameFile= strrep(newNameFile,'NewAst/P21lkhv/','./');
%newNameFile= strrep(newNameFile,'NewAst/P21ltbf/','./');
%Reference image name
%refImageName=strrep(nameF{1}(refImg),'NewAst/P21lkhv/','');
%refImageName=strrep(nameF{1}(refImg),'NewAst/P21ltbf/','');

debug=0;
%Write Data Cube
for nimg=1:NF
    wfits_AL01(...
        AlignCube(:,:,nimg),...
	    nameF{1}(nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        refImageName,...
        minCoor(nimg,:),...
        maxCoor(nimg,:),...
        uArea(1,:),...
        uArea(2,:),...
        transformR(nimg,1),...
        transformR(nimg,2),...
        NF,...
       theTR{nimg} ,...
        {'LOG'},...
        radio,...
        minArea,...
        maxArea,...
        ncomm,...
        DATEOBS{nimg},...
        JD{nimg},...
         EXPTIME{nimg},...
        debug);     
end
toc


