%%
% Asteroid Finder Median and Sky Background
%

fprintf('\n##################################\n');
fprintf('Median and remove sky backgounf trends\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  

%listFile='P21lkhv_list_AL.txt';
listFile='475665_list_AL.txt';


[nameF,NF]=readList(listFile);
DATEOBS=cell(NF,1);
EXPTIME=cell(NF,1);
JD=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);
for nimg=1:NF
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    JD{nimg}=readHDR(nameF{1}(nimg,:),'JD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(1);
     minCoor2(nimg,2)=theVal(3);
     maxCoor2(nimg,1)=theVal(2);
     maxCoor2(nimg,2)=theVal(4);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc

%%
% Compute the Median
%
fprintf('\n#####################\n');
fprintf('Step 2: Compute the aligned median and the differences of median\n');
tic
fileMedian='S475665_Median_AL.fits';
fileCubeMedian='S475665_DiffOfMedianCube_AL.fits';
[DM,Median_newCube]=diffOfMedian(Dcube); 
minU=max(minCoor2);
maxU=min(maxCoor2);

debug=0;
wfits_AL05(...
        Median_newCube,...
       fileMedian, ...
       fileMedian, ...
        minCoor(1,:),...
        maxCoor(1,:),...
        minU,...
        maxU,...
        DATEOBS{1},...
        JD{1},...
        ' ',...
        EXPTIME{1},...
        debug); 
 
 wfits_AL05(...
        DM,...
       fileCubeMedian, ...
       fileCubeMedian, ...
        minCoor(1,:),...
        maxCoor(1,:),...
        minU, ...
        maxU,...
        DATEOBS{1},...
        JD{1},...
        ' ',...
       EXPTIME{1},...
        debug); 
clear DM Median_newCube
toc
%%
% Sky  background trend 
fprintf('\n#####################\n');
fprintf('Step 3: Remove sky background trend & write data\n');
tic
debug=2;
% Use ds9 to slectect background regions and save it using IRAF pro format
%skRegFile='P21ltbf_R3AL.reg';
skRegFile='S475665_R4AL.reg';
theReg=readRegionDs9(skRegFile);
%Otherwise write manualy the Region Description
% theReg: [Xc,Yc,Widht,Hight]

[skCube,skMedian,skStd,skMean]=skyAdjust2(single(Dcube),theReg);
skCube=int16(skCube);
if debug 
    theMean=mean(skMedian);
    A=zeros(size(skMedian));
    A(:)=theMean;
    theFac=theMean - skMedian;
    plot([skMedian.' theFac.'+ theMean A.']) ;
    xlabel('Image No');
    ylabel('Counts');
    title('Background Median Trends [475665]');
    % To save graph.
    %saveas(gcf,'P21ltbf_BackgroundTrend.png');
end

clear Dcube;
%%
%Write the data
fprintf('\n#####################\n');
fprintf('Step 4: Write fits \n');


outDir='./';
[newNameFile,onlyNewName] = changeNames(nameF{1},'S.fits',outDir);
%newNameFile= strrep(nameF{1},'.fits','S.fits');
% remove the directory
%onlyNewName=strrep(newNameFile,'NewAst/P21lkhv_AL/','');
%onlyNewName=strrep(newNameFile,'NewAst/P21ltbf_AL/','');
% change de original directory to working directorory "./"
%newNameFile= strrep(newNameFile,'NewAst/P21lkhv_AL/','./');
%newNameFile= strrep(newNameFile,'NewAst/P21ltbf_AL/','./');
%Reference image name
debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL05(...
        skCube(:,:,nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        minCoor(nimg,:),...
        maxCoor(nimg,:),...
        minU,...
        maxU,...
        DATEOBS{nimg},...
        JD{nimg},...
        ' ',...
         EXPTIME{nimg},...
        debug);     
end
toc

%fitswrite(skCube,'P21ltbf_CubeALS.fits')

