%%
%Apply a mask over the hold data cube
%T

fprintf('\n##################################\n');
fprintf('Aplico la mascara al cubo de datos\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  

%listFile='P21lkhv_list_AL.txt';
listFile='475665_list_ALS.txt';

[nameF,NF]=readList(listFile);
DATEOBS=cell(NF,1);
EXPTIME=cell(NF,1);
JD=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);
for nimg=1:NF
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    JD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(1);
     minCoor2(nimg,2)=theVal(3);
     maxCoor2(nimg,1)=theVal(2);
     maxCoor2(nimg,2)=theVal(4);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc
%%
fprintf('\n#####################\n');
fprintf('Step 2: Read the Mask \n');
tic

%fileMask='FZ_Mask_AL2S_STD.fits'; % With standar deviation
fileMask='S475665_Mask_ALS.fits';

theMask=logical(fitsread(char(fileMask)));
ATYPEF=readHDR(char(fileMask),'ATYPEF','%s');
% posible values Diff-off-Median "DoffM" ; Raw-Data "Raw" 
%maskTo='DoffM'; % posible values [Raw|DofM]
maskTo='Raw';
%maskTo='DoffM';
bgFlag=0; 

skRegFile='S475665_R4AL.reg';

theReg=readRegionDs9(skRegFile);

patchCube=patchStar_File(Dcube,theMask,theReg,ATYPEF , maskTo, bgFlag);
toc
%%
fprintf('\n#####################\n');
fprintf('Step 3: Write Data \n');
tic

%Write the data
outDir='./';
[newNameFile,onlyNewName] = changeNames(nameF{1},'MP.fits',outDir);
%newNameFile= strrep(nameF{1},'.fits','MP.fits');
%newNameFile= strrep(nameF{1},'_C0.fits','MP_C0.fits');
% remove the directory
%onlyNewName=strrep(newNameFile,'NewAst/P21ltbf_AL/','');
%onlyNewName=strrep(newNameFile,'DDoti_02/','');
% change de original directory to working directorory "./"
%newNameFile= strrep(newNameFile,'NewAst/P21ltbf_AL/','./');
%newNameFile= strrep(newNameFile,'DDoti_02/','./');

debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL06(...
        patchCube(:,:,nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        fileMask, ...
        maskTo, ...
         minCoor(nimg,:),...
         maxCoor(nimg,:),...
        minCoor2(nimg,:),...
        maxCoor2(nimg,:),...
        DATEOBS{nimg},...
        JD{nimg},...
        ' ',...
         EXPTIME{nimg},...
        debug);     
end

toc 

