%% these lines just import an image and subtract background in order to detect the objects
I = imread('image1.png');
B = imread('bknd.png');
D = imabsdiff(I,B);
Db = im2bw(D,[],0.07); % image is thresholded and binarized
Db2 = bwareaopen(Db, 5); % remove objects having less than 5 pixels
se = strel('disk',6,6);  % shape used to dilate objects
Db3 = imdilate(Db2,se);
f= figure();
[labeledImage, numSpots] = bwlabel(Db3);
boundaries=bwboundaries(labeledImage); % coordinates of blob boundaries: I initially thought to use them but they are kind of offset relative to the blobs which makes them useless
stats = regionprops('struct',Db3,'Centroid','PixelList','PixelIdxList','Orientation','MajorAxisLength','MinorAxisLength');
centers = vertcat(stats.Centroid); % [stats(1).Centroid(1), stats(1).Centroid(2);stats(2).Centroid(1), stats(2).Centroid(2)];
angles =  horzcat(stats.Orientation);
pixels = stats.PixelList;
pixel_idx = stats.PixelIdxList;
diameters = mean([stats.MajorAxisLength stats.MinorAxisLength],2);
radii = diameters/2;
Major_axes = horzcat(stats.MajorAxisLength);
Minor_axes = horzcat(stats.MinorAxisLength);
imshow(labeledImage)
 
%% find centroid axes
hold on
scatter(centers(:,1),centers(:,2),'r','filled')
