%%
%DDOTI/OAN 28-cm f/2.2
% Second Alling process
% a-2002-silva-0
%Field 16:50:30.0 -02:39:30
%2021-06-15T
%CCDSEC  = '[1:6144,55:6198]'                                                    
%DATASEC = '[1:6144,55:6198]'                                                    
% BIASSEC = '[1:6144,7:22]'
% Master dir FZ/FZ_C0_06_15/
%
% 
%clear all

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube, Median of C0 and C5, \n and read the rigid trasform parameters\n');
tic  
% read the List
%listFile='FZ_list_C0.txt';
%listFile='FZ_list_Aligned_20I.txt';  % list of the 1st Allinf process
listFile='FZ_list_Aligned1.txt';
% 
listFile2='FZ_Median.txt';     %list of Median with rigid trasnform info
%listFile='FZ_list.txt'; %Full list
[nameF,NF]=readList(listFile);
[nameF2,NF2]=readList(listFile2);

transformRMaster=cell(NF2,2);
groupMasterCCD=cell(NF2,1);

for nimg=1:NF2
    transformRMaster{nimg,1}(1,1)=readHDR(nameF2{1}(nimg,:),'ACD1_1','%d');
    transformRMaster{nimg,1}(1,2)=readHDR(nameF2{1}(nimg,:),'ACD1_2','%d');
    transformRMaster{nimg,1}(2,1)=readHDR(nameF2{1}(nimg,:),'ACD2_1','%d');
    transformRMaster{nimg,1}(2,2)=readHDR(nameF2{1}(nimg,:),'ACD2_2','%d');
    transformRMaster{nimg,2}(1,1)=readHDR(nameF2{1}(nimg,:),'ATV1','%d');
    transformRMaster{nimg,2}(2,1)=readHDR(nameF2{1}(nimg,:),'ATV2','%d');
    groupMasterCCD{nimg}=readHDR(nameF2{1}(nimg,:),'CCD_NAME','%s');
end
pivotImg=1;
pivotName=readHDR(nameF2{1}(pivotImg,:),'ANAME','%s');

CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);

transformR=cell(NF,2);
C0=[1,100];
C5=[101,187];
%C0=[1,5]; % [C0_ini,C0_end] according the file list
%C5=[6,10]; % [C5_ini,C5_end] according the file list

%
for nimg=1:NF
    CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
    if strcmp(CCD{nimg},'C0')
       transformR{nimg,1}= transformRMaster{1,1};
       transformR{nimg,2}= transformRMaster{1,2};
    elseif strcmp(CCD{nimg},'C5')
       transformR{nimg,1}= transformRMaster{2,1};
       transformR{nimg,2}= transformRMaster{2,2};
    else
        fprintf('Error: the file %s does not correspond to CDD [C0|C5]\n',char(nameF{1}(nimg,:)));
        fprintf('Error: Aborting ...');
        return;
    end
end

parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end

uAreaPrev(1,1)=max(minCoor(:,1));
uAreaPrev(1,2)=max(minCoor(:,2));
uAreaPrev(2,1)=min(maxCoor(:,1));
uAreaPrev(2,2)=min(maxCoor(:,2));

toc
% Info header that I need C0/C5
%DATE-OBS = in file
%MJD  = in file
%CCD_NAME  = in file 
%EXPTIME  = in file
%AREFNAME=pivotName
%  for C0
% AAREA = in original file
% Rigid traslation =  transformRMaster pivot
%  for C5
%  AAREA =  computed
%  Rigid traslation =  transformRMaster C5 median

%%  Align Images
fprintf('\n#####################\n');
fprintf('Step 2: Aling images \n');

tic
AlignCube=zeros(size(Dcube),'like',Dcube);
AlignCube(:,:,1)=Dcube(:,:,1);
 [sizeX, sizeY,~]=size(Dcube);
parfor nimg=C5(1):C5(2)
    %if  strcmp(CCD{5nimg},'C5')
        [AlignCube(:,:,nimg), minCoor(nimg,:),maxCoor(nimg,:)] = ...
        doAlign02( Dcube(:,:,nimg) , [sizeX sizeY] ,transformR{nimg,1},transformR{nimg,2});
    %else
     %  AlignCube(:,:,nimg)=Dcube(:,:,nimg);
    %end
end
AlignCube(:,:,C0(1):C0(2))=Dcube(:,:,C0(1):C0(2));
clear Dcube
toc
%% 
% Write the  alligned Data.
fprintf('\n#####################\n');
fprintf('Step 3: Write data aligned data cube 2nd process\n');
tic
% Add "*2.fits"  to the original name
newNameFile= strrep(nameF{1},'.fits','2.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'DDotiAL01/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'DDotiAL01/','./');
%Reference image name
refImageName=pivotName;
debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL03(...
        AlignCube(:,:,nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        refImageName,...
        minCoor(nimg,:),...
        maxCoor(nimg,:),...
        transformR(nimg,1),...
        transformR(nimg,2),...
        NF,...
        DATEOBS{nimg},...
        MJD{nimg},...
        CCD{nimg},...
         EXPTIME{nimg},...
        debug);     
end


toc

%%
% Write the median and difference of median cube
%
fprintf('\n#####################\n');
fprintf('Step 4: Compute the aligned median and the differences of median\n');
tic
fileMedian='FZ_MedianCubeBrAL2.fits';
fileCubeMedian='FZ_CubeRemovedMedianBrAL2.fits';
[DM,Median_newCube]=diffOfMedian(AlignCube); 
DM=int16(DM);
Median_newCube=int16(Median_newCube);

fitswrite(Median_newCube,fileMedian);
fitswrite(DM,fileCubeMedian);
clear DM Median_newCube
toc

%% Compute  usuable Area and enhanced  the frames according the sky level 
fprintf('\n#####################\n');
fprintf('Step 5:Write only usuable area\n');
tic
uArea=zeros(2,2); % row1  min';  row 2  max; (x,y) coord

uArea(1,1)=max(minCoor(:,1));
uArea(1,2)=max(minCoor(:,2));
uArea(2,1)=min(maxCoor(:,1));
uArea(2,2)=min(maxCoor(:,2));

uArea(1,:)=max(uArea(1,:),uAreaPrev(1,:));
uArea(2,:)=min(uArea(2,:),uAreaPrev(2,:));

newCube=AlignCube(uArea(1,2):uArea(2,2), uArea(1,1):uArea(2,1),:);
clear AlignCube

%Write only the usuable area for aligned data 
newNameFile= strrep(nameF{1},'.fits','2U.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'DDotiAL01/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'DDotiAL01/','./');
%Reference image name
debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL04(...
        newCube(:,:,nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        uArea(1,:),...
        uArea(2,:),...
        DATEOBS{nimg},...
        MJD{nimg},...
        CCD{nimg},...
         EXPTIME{nimg},...
        debug);     
end

%%  The change of the brilliants of the sky is removed throughout the acquisition.
% Optional
% I need 3 region box,  I suggest to use Mediian image and ds9 regions
%tools. Of course you can use only one  region
fprintf('\n#####################\n');
fprintf('Step 6: Remove sky background trend & write data\n');

fileMedian='FZ_MedianCubeBrAL2U.fits'; % only usable area
[Median_newCube]= onlyMedian(newCube);
Median_newCube=int16(Median_newCube);
fitswrite(Median_newCube,fileMedian);
clear Median_newCube
% Use ds9 to slectect the regions and save it using IRAF pro format
skRegFile='FZ_MedianU.reg';
theReg=readRegionDs9(skRegFile);

%Otherwise write manualy the Region Description
% theReg: [Xc,Yc,Widht,Hight]

[skCube,skMedian,skStd,skMean]=skyAdjust2(single(newCube),theReg);
skCube=int16(skCube);
clear newCube;
%Write the data
newNameFile= strrep(nameF{1},'.fits','2US.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'DDotiAL01/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'DDotiAL01/','./');
%Reference image name
debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL04(...
        skCube(:,:,nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        uArea(1,:),...
        uArea(2,:),...
        DATEOBS{nimg},...
        MJD{nimg},...
        CCD{nimg},...
         EXPTIME{nimg},...
        debug);     
end

fitswrite(skCube,'FZ_CubeBrAL2US.fits');
toc
%% Differences over the median may be works better than raw Image
fprintf('\n#####################\n');
fprintf('Step 7: Remove stars \n');
tic
facBg= sqrt(2);  %Factor of the background to detect stars
bgFlag=1; % replace the minum valus with the background
radiusOfD=5; % Radius of dilation image
debug=0;
skCube_m=DofMbg(single(skCube),theReg, facBg,bgFlag, radiusOfD, debug);
clear  skCube
skCube_m=int16(skCube_m);

%Write the data
newNameFile= strrep(nameF{1},'.fits','2USM.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'DDotiAL01/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'DDotiAL01/','./');
%Reference image name
debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL04(...
        skCube_m(:,:,nimg),...
        newNameFile{nimg}, ...
        onlyNewName{nimg}, ...
        uArea(1,:),...
        uArea(2,:),...
        DATEOBS{nimg},...
        MJD{nimg},...
        CCD{nimg},...
         EXPTIME{nimg},...
        debug);     
end
fitswrite(skCube_m,'FZ_CubeBrAL2USM.fits');
toc
%%Examples
%[Ex01_sk, m1, m2] = sumShift(skCube,[-0.536,0.778]);


