%%
%DDOTI/OAN 28-cm f/2.2
% Second Alling process
% a-2002-silva-0
%Field 16:50:30.0 -02:39:30
%2021-06-15T
%CCDSEC  = '[1:6144,55:6198]'                                                    
%DATASEC = '[1:6144,55:6198]'                                                    
% BIASSEC = '[1:6144,7:22]'
% Master dir FZ/FZ_C0_06_15/
%
% Geneations of a "patch"around the stars, in the data cube.
%This process does not  substract the median of the data cube over itself

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  
%listFile='FZ_list_Aligned_BrAL2US.txt'; % only the usuable area 
listFile='FZ_list_Aligned_BrAL2.txt'; % Compleate area
[nameF,NF]=readList(listFile);

CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);

for nimg=1:NF
    CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc
%%
%
%
fprintf('\n#####################\n');
fprintf('Step 2: Remove stars \n');
tic
skRegFile='FZ_MedianU.reg';
theReg=readRegionDs9(skRegFile);

%facBg= sqrt(2);  %Factor of the background to detect stars
facBg=2.5;
bgFlag=1; % replace the minum valus with the background
radiusOfD=5; % Radius of dilation image
debug=0;
patchCube=patchStar(single(Dcube),theReg, facBg,bgFlag, radiusOfD, debug);

clear  Dcube
patchCube=int16(patchCube);
toc

%%Write the data
fprintf('\n#####################\n');
fprintf('Step 3: Wri te Data  \n');
tic

newNameFile= strrep(nameF{1},'.fits','P.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'DDotiAL01/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'DDotiAL01/','./');
%Reference image name
debug=0;
uArea=zeros(2,2);
uArea(1,1)=max(minCoor(:,1));
uArea(1,2)=max(minCoor(:,2));
uArea(2,1)=min(maxCoor(:,1));
uArea(2,2)=min(maxCoor(:,2));

%Write Data Cube
parfor nimg=1:NF
    wfits_AL04(...
        patchCube(:,:,nimg),...
        newNameFile{nimg}, ...
        onlyNewName{nimg}, ...
        uArea(1,:),...
        uArea(2,:),...
        DATEOBS{nimg},...
        MJD{nimg},...
        CCD{nimg},...
         EXPTIME{nimg},...
        debug);     
end
fitswrite(patchCube,'FZ_CubeBrAL2USP.fits');
toc
%%

%SIdx=cell(10,1)
%DIdx=cell(10,1);
% [SIdx{1},DIdx{1}]=noncircshiftOnlyIndex(size(A),[-2,1]);
%[SIdx{2},DIdx{2}]=noncircshiftOnlyIndex(size(A),[-3,2]);
%C=A;
%C(DIdx{1}{:})=C(DIdx{1}{:})+A(SIdx{1}{:});
%C(DIdx{2}{:})=C(DIdx{1}{:})+A(SIdx{2}{:});



