%%
%DDOTI/OAN 28-cm f/2.2
% Second Alling process
% a-2002-silva-0
%Field 16:50:30.0 -02:39:30
%This process does not  substract the median of the data cube over itself

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  
%listFile='FZ_list_Aligned_BrAL2US.txt'; % only the usuable area 
listFile='FZ_list_Aligned_BrAL2S.txt'; % Compleate area
%listFile='FZ_list_Aligned_BrALS_C0.txt'; % Compleate area
[nameF,NF]=readList(listFile);

CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor1=zeros(NF,2);
maxCoor1=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);

for nimg=1:NF
    CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor1(nimg,1)=theVal(3);
     minCoor1(nimg,2)=theVal(1);
     maxCoor1(nimg,1)=theVal(4);
     maxCoor1(nimg,2)=theVal(2);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(3);
     minCoor2(nimg,2)=theVal(1);
     maxCoor2(nimg,1)=theVal(4);
     maxCoor2(nimg,2)=theVal(2);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc

%%
fprintf('\n#####################\n');
fprintf('Step 2: Read the Mask \n');
tic

%fileMask='FZ_Mask_AL2S_STD.fits'; % With standar deviation
fileMask='FZ_Mask_ALS_C0_STD.fits'; 
theMask=logical(fitsread(char(fileMask)));
ATYPEF=readHDR(char(fileMask),'ATYPEF','%s');
% posible values Diff-off-Media "DoffM" ; Raw-Data "Raw" 
maskTo='DoffM'; % posible values Raw DofM
bgFlag=0; 

skRegFile='FZ_Median_BrAL2.reg';
theReg=readRegionDs9(skRegFile);

patchCube=patchStar_File(Dcube,theMask,theReg,ATYPEF , maskTo, bgFlag);
toc

%%
fprintf('\n#####################\n');
fprintf('Step 3: Write Data \n');
tic

%Write the data
newNameFile= strrep(nameF{1},'.fits','MP.2.fits');
%newNameFile= strrep(nameF{1},'_C0.fits','MP_C0.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'DDotiAL01/','');
%onlyNewName=strrep(newNameFile,'DDoti_02/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'DDotiAL01/','./');
%newNameFile= strrep(newNameFile,'DDoti_02/','./');

debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL06(...
        patchCube(:,:,nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        fileMask, ...
        maskTo, ...
         minCoor1(nimg,:),...
         maxCoor1(nimg,:),...
        minCoor2(nimg,:),...
        maxCoor2(nimg,:),...
        DATEOBS{nimg},...
        MJD{nimg},...
        CCD{nimg},...
         EXPTIME{nimg},...
        debug);     
end

toc 



