%%
%DDOTI/OAN 28-cm f/2.2
% Second Alling process
% a-2002-silva-0
%Field 16:50:30.0 -02:39:30
%2021-06-15T
%CCDSEC  = '[1:6144,55:6198]'                                                    
%DATASEC = '[1:6144,55:6198]'                                                    
% BIASSEC = '[1:6144,7:22]'
% Master dir FZ/FZ_C0_06_15/
%
% Generate  Only the Mask
%This process does not  substract the median of the data cube over itself

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  
%listFile='FZ_list_Aligned_BrAL2US.txt'; % only the usuable area 
listFile='FZ_list_Aligned_BrALS_C0.txt'; % Compleate area
[nameF,NF]=readList(listFile);

CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor1=zeros(NF,2);
maxCoor1=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);

for nimg=1:NF
    CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor1(nimg,1)=theVal(3);
     minCoor1(nimg,2)=theVal(1);
     maxCoor1(nimg,1)=theVal(4);
     maxCoor1(nimg,2)=theVal(2);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(3);
     minCoor2(nimg,2)=theVal(1);
     maxCoor2(nimg,1)=theVal(4);
     maxCoor2(nimg,2)=theVal(2);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc
%%
fprintf('\n#####################\n');
fprintf('Step 2: Mask Gnerations \n');
tic

skRegFile='FZ_Median_BrAL2.reg';
theReg=readRegionDs9(skRegFile);
%facBg= sqrt(2);  %Factor of the background to detect stars
%theFact=2.5; %Background factor to detect stars
theFact=sqrt(2);
radiusOfD=5; % Radius of dilation image
minStars=6000;  %5000
maxStars=9000;  %6000
debug=0;
typeFactor= 'Std'; % Use Standar deviation

[theMask, ...
    objCentroid, ...
    objArea,...
    objBox,...
    numObj,...
    finalFactor,...
    theVal] =patchStar_onlyMask(...
        Dcube,...
        theReg, ...
        theFact, ...
        radiusOfD, ...
        minStars,...
        maxStars,...
        typeFactor, ...
        debug);

toc
%%
fprintf('\n#####################\n');
fprintf('Step 3: Write The mask \n');
tic

maskName='FZ_Mask_ALS_C0_STD.fits';
maskNameTable='FZ_MaskTable_ALS_C0_STD.fits';
uArea1=zeros(2,2);
dim=size(theMask);
uArea1(1,1)=1;
uArea1(1,2)=1;
uArea1(2,1)=dim(2);
uArea1(2,2)=dim(1);

wfits_ALMask(...
        theMask,...
       maskName, ...
       maskName , ...
        uArea1(1,:),...
        uArea1(2,:),...
        minCoor2(1,:),...
        maxCoor2(1,:),...
        radiusOfD,...
        minStars,...
        maxStars,...
        typeFactor, ...
        theFact, ...
        finalFactor,...
        theVal,...
        numObj,...
        DATEOBS{1},...
        MJD{1},...
        CCD{1},...
       EXPTIME{1},...
        debug)

theTable=[objCentroid,double(objArea),double(objBox)];
fitswrite(theTable,char(maskNameTable));
import matlab.io.*
fptr= fits.openFile(char(maskNameTable),'readwrite');
fits.writeComment(fptr,'Aligned data cube allgoritms, TAOSII team');
fits.writeComment(fptr,'Authors: BHV/JSS/ESM');
dt=datetime('now');
sdt= sprintf('Date of Run: %s',dt);
fits.writeComment(fptr,sdt);
fits.writeComment(fptr,'Description table of found objects, sorted by area');
fits.writeComment(fptr,'Centroid [xc,yc]');
fits.writeComment(fptr,'Area [A]');
fits.writeComment(fptr,'ObjectBox: upper left corner [x1,y1], width, height');
fits.writeComment(fptr,'[xc, yc, A, x1, y1, width, height]');
fits.closeFile(fptr);

toc


%%
    