function [fullName,onlyNewName] = changeNames(oldName,postFix,newDir)
%Remove the directory and its extention from a list of file names. 
%The new string includes the postfix to be appendend to the original
%names and the new directory where the results will be written.
%
%   Usage: [fullName, onlyNewName]=changeNames(oldName,postFix,outDir)
%
%Input
%   oldName: Old name files with path and extensions
%   postFix: Postfix string  
%   newDir:  New directory name
%Ouput
%   fullName:  The new names
%
% BHV Nov 2022

[~,nName,~] = fileparts(oldName);

fullName=strcat(newDir,nName,postFix);
onlyNewName=strcat(nName,postFix);


end