function [OImage] = cropMatrix(Img, theRange)
%Extarct a subsection of a matrix similar to the format ofthe DATASEC
%keyword in fits files
%
%   Usage: cropFitsImage('[minX:maxX,minY:maxY]')
%Input
%   Img: input image matrix
%   '[minX:maxX,minY:maxY]' : String minX = minimum of the axis1;  
%           maxX = maximum of the axis1; minY = minimum of the axis2;
%           maxY = maximum of the axis2;
%Output
%   OImage: new matrix 
%
%Author: BHV
%Release 1.0 Nov 2022 
%
if ~ischar(theRange)    % check if the value is a numeric
    OImage=[];
    fprintf('Error: theRange variable is not a character\n');
    fprintf('Error: Aborting .... \n');
    return
end


scArea=sscanf(theRange,'[%d:%d,%d:%d]');
scRows=scArea(4)-scArea(3)+1;
scCols=scArea(2)-scArea(1)+1;
OImage=zeros(scRows , scCols, 'like',Img);

OImage=Img(scArea(3):scArea(4),scArea(1):scArea(2));


end