function [ objAreaF,objCentroidF,  objBoxF, objEccF] = detectAsteroide( ...
    Data,...
    usuAmin,...
    usuAmax,...
    theV, ...
    facStd,...
    radius,...
    minBlobArea,...
    maxBlobArea,...
    debug)
%Detect an Asteroid
%   Detailed explanation goes here

rmin=usuAmin(2);
rmax=usuAmax(2);
cmin=usuAmin(1);
cmax=usuAmax(1);

A=Data(rmin:rmax,cmin:cmax);
A=normalizeData(A,'log');
a=mean(A(:));
b=std(A(:));
u=a+facStd*b;

B=A>u;
morfR=strel('disk',radius,0);
C=imopen(B,morfR);



%theBlob=vision.BlobAnalysis('MinimumBlobArea',minBlobArea,...
%'MaximumBlobArea',maxBlobArea,...
%'MajorAxisLengthOutputPort', 1,...
%'MinorAxisLengthOutputPort', 1, ...
%'OrientationOutputPort', 1,...
%'EccentricityOutputPort', 1);
theBlob=vision.BlobAnalysis('MinimumBlobArea',minBlobArea,...
    'MaximumBlobArea',maxBlobArea,...
    'EccentricityOutputPort', 1);

%[objArea,objCentroid,objBox,objMay,objMin,objOri,objEcc]=step(theBlob,C);
[objArea,objCentroid,objBox,objEcc]=step(theBlob,C);
numObj=numel(objArea);
finalObj=0;
for ii=1:numObj
    if (objEcc(ii) < 0.3 && objEcc(ii) >= 0 )
        finalObj=finalObj+1;
        objAreaF(finalObj)=objArea(ii);
        objCentroidF(finalObj,:)=objCentroid(ii,:);
        objBoxF(finalObj,:)=objBox(ii,:);
        objEccF(finalObj)=objEcc(ii);
    end
end


if debug && finalObj
    imgShape= insertShape(A,'rectangle',objBoxF,'Linewidth',2,'Color',[255 0 0]);
    imshow(imgShape);
    t=sprintf('Image vx: %6.4f ; vy= %6.4f ; Asteroids=%d',theV(1),theV(2),finalObj);
    title(t);
end



end

