function [ DofM,Median ] = diffOfMedian( DataCube )
% Diferences of Median on a data cube
%   Usage  [ DofM,Median ] = diffOfMedian( DataCube)
%  Input
%  DataCube: The frames
%  Output
%    DofM: DataCube of diferences of Median
%    Median: the Median Image
%
%
%BH Mayo 221
dim=size(DataCube);
DofM=zeros(dim,'like',DataCube);

Median=int16(median(DataCube,3));

parfor n=1:dim(3)
    DofM(:,:,n)=DataCube(:,:,n)-Median;
end

DofM(DofM < 1)=1;

DofM=int16(DofM);

end

