function [ alignedData, minV, maxV ] = doAlign( DataM, max_XY, R, T )
%Align a image according the rigid transform R+T
%   USAGE:  [ alignedData, minV, maxV ] = doAlign( DataM, max_XY, R, T )


alignedData=zeros(max_XY(2),max_XY(1),'like',DataM);
minV=[1,1];
maxV=max_XY;
%thePoint=zeros(1,2);
for col_x=1:max_XY(1)
     for ren_y=1:max_XY(2)
       thePoint= newCoordinate(R,T,[col_x,ren_y]);
       if  (thePoint(1) >= 1 && ...
             thePoint(1) <=  max_XY(1) && ...
             thePoint(2) >= 1 && ...
             thePoint(2) <=  max_XY(2))
         alignedData( thePoint(2),thePoint(1)) = DataM(ren_y,col_x);
       end
    end
end

% Analize the usuable area

PM=zeros(4,2);
PM(1,:)= newCoordinate(R,T,[1,1]);
PM(2,:)= newCoordinate(R,T,[1,max_XY(2)]);
PM(3,:)= newCoordinate(R,T,[max_XY(1),1]);
PM(4,:)= newCoordinate(R,T,max_XY);


if PM(1,1) >  minV(1)
     minV(1) = PM(1,1);
end
if PM(2,1)   >  minV(1)
     minV(1) = PM(2,1);
end
if PM(1,2) >  minV(2)
     minV(2) = PM(1,2);
end
if PM(3,2)   >  minV(2)
     minV(2) = PM(3,2);
end

if  PM(3,1) <  maxV(1)
     maxV(1) = PM(3,1);
end
if  PM(4,1) <  maxV(1)
     maxV(1) = PM(4,1);
end
if  PM(2,2) <  maxV(2)
     maxV(2) = PM(2,2);
end
if  PM(4,2) <  maxV(2)
     maxV(2) = PM(4,2);
end
    
% If a pixel(x,y) in the new image has no  pixel  correspondence 
% to the original image, I replace it with the mean of its neighbors.
% This is  a effect of the rounding  process
K=ones(3,3);
K=K./9;

[ry,cx]=find(alignedData(minV(2):maxV(2),minV(1):maxV(1)) == 0);
ry=ry+minV(2)-1;
cx=cx+minV(1)-1;

for i=1:length(ry)
    if ( ry(i) > 1 && ...
           ry(i) < max_XY(2) && ...
           cx(i) > 1  && ...
            cx(i) < max_XY(2) )
        p=conv2( alignedData( ry(i)-1:ry(i)+1 , cx(i)-1:cx(i)+1),K,'valid');
        alignedData( ry(i), cx(i))=p;
    end
end


%At the boundary image is normal that exist no pixel correpondence,
%I replace it with median of the image
    zv=median( DataM(:));
    alignedData(alignedData==0)= zv;
    
    
end

