function [ objArea,objCentroid,objBox, numObj] = findPoints2( ...
    theImg, ...
    vthresh, ...
    radius, ...
    minBlobArea, ...
    maxBlobArea, ...
    nameFile, ...
    debug)
% Find control star position for alling process
%   Detailed explanation goes here

 theImgL=log(theImg);
  fact=1/(max(theImgL(:))-min(theImgL(:)));
  themin=min(theImgL(:));
  theImgNor=(theImgL - themin).*fact;
  
 %theImg_A=zeros(size(theImg));
 A=theImgNor>vthresh(1);
 B=theImgNor<vthresh(2) ;
 theImg_A=logical(A.*B);
%  theImg_A= theImg_A<vthresh(2);

  morf_r2=strel('disk',radius);
  theImage_B=imopen( theImg_A,morf_r2);
  
  theBlob=vision.BlobAnalysis('MinimumBlobArea',minBlobArea,...
       'MaximumBlobArea',maxBlobArea);
   
   [objArea,objCentroid,objBox]=step(theBlob,theImage_B);
   numObj=numel(objArea);
   
   if numObj < 1
       return;
   end
   if debug
       
       if debug == 2
       figure(1)
       subplot(1,3,1);
        imshow(theImgNor); 
        title('Image');
        c = colorbar('southoutside');
        c.Label.String = 'log';
        
        subplot(1,3,2);
        imshow(theImg_A); 
        t=sprintf('Threshold: %4.2f,%4.2f',vthresh(1),vthresh(2));
        title(t);
        c = colorbar('southoutside');
        c.Label.String = 'log';
        
        subplot(1,3,3);
        imshow(theImage_B); 
        t=sprintf('Morfoligical disk r=%d',radius);
        title(t);
        c = colorbar('southoutside');
        c.Label.String = 'binary';
        pause(1);
         fprintf('\n\t Points found:\n');
         fprintf(' \t Name: %s\n',char(nameFile));
         fprintf(' \t Threshold: %4.2f,%4.2f, \n',vthresh(1),vthresh(2));
          fprintf(' \t Disk params [radius,minArea,maxArea]: %6.2f %6.2f  %6.2f \n',radius, minBlobArea,maxBlobArea);
          fprintf(' \t Op: P[j] Centroide\n');
           for i=1:numObj
                fprintf('\t [%d]: P%d (%6.2f, %6.2f)\n',i,i,objCentroid(i,1), objCentroid(i,2));
           end
       end
       
        figure(2)
        
        
         delta=4;
        bboxOut_2(:,1)=objBox(:,1)-delta;
        bboxOut_2(:,2)=objBox(:,2)-delta;
        bboxOut_2(:,3)=objBox(:,3)+2*delta;
        bboxOut_2(:,4)=objBox(:,4)+2*delta;
        imgShape= insertShape(theImgNor,'rectangle',bboxOut_2,'Linewidth',2,'Color',[255 0 0]);
        imshow(imgShape);
        
        delta2=10;
        textPos=round(objCentroid+delta2);
         imgSize=size(theImg);
        xmax=imgSize(2);
        ymax=imgSize(1);
        for i=1:numObj
            if(textPos(i,1) > (xmax -50))
                 textPos(i,1)=round(objCentroid(i,1)-(2*delta2));
            end
            if(textPos(i,2) > (ymax -20))
              textPos(i,2)=round(objCentroid(i,2)-(2*delta2));
            end
        end
   
        text_objstr = cell(numObj,1);
        for i=1:numObj
                text_objstr{i}=['P[' num2str(i,'%d') ']' ];
        end
   
        imgShapeText=insertText(imgShape,  textPos, text_objstr, ...
        'TextColor','yellow','FontSize',18,'BoxColor' ,[1 1 1],...
         'BoxOpacity',0);
        imshow(imgShapeText);
         t=sprintf('%s ',char(nameFile));
         t2=sprintf('Points found: %d',numObj);
        title([t,t2],'Interpreter', 'none');
        
    
        
   end
   
 
end

