function [ vShift] = pixvecVelocityGaps( MJD,pv,sizeCube)
%Determine the shift over DataCube, and include possible gaps 
%  USAGE:  [ vPixel ] = pixvecVelocityGaps( MJD,pv,sizeCube)
%Input: 
% MJD:  Julian Date by header
% pv: velocity pixel  vector [vx,vy]
% sizeCube: [rows, colmn, deep]
%
%Outuput
% vShift: Velocity pixel matrix [deep,[velCol_Y, velRen_X]]]; 
%
%BHV Sep 2021
% Modification Nov 2022
% The minimum (minCoor ) and  maximum (maxCoor) coordane are eliminated. 
% This proccess will be calclated into another  routine

rtot=sizeCube(1);
ctot=sizeCube(2);
deep=sizeCube(3);

KJD=2400000; % Date factor for short Julina date
VMJD=cell2mat(MJD)+KJD;
difDate=diff(datetime(VMJD ,'convertfrom','juliandate')); %diferences between obs
eSec=seconds(difDate); % elapsed time in second
 % I suppose that some few observation has a big desviaton over the median 
meSec=median(eSec); % the medina is the elepsed time in the observation

% calculate the skeep factor
skeepF=zeros(deep,1);
 
for j=2:deep
        %skeepF(j)= round(abs(eSec(j-1)-meSec)/meSec);
        skeepF(j)= abs(eSec(j-1)-meSec)/meSec;
end

vShift=zeros(deep,2);
%minCoor=ones(2,1);
%maxCoor=zeros(2,1);
%maxCoor(1)=ctot;
%maxCoor(2)=rtot;

ssx=1; 
ssy=1;
if(pv(1) < 0 )
    ssx=-1;
end
if(pv(2) < 0 )
    ssy=-1;
end
k_x=-pv(1)-0.4999*ssx;
k_y=-pv(2)-0.4999*ssy;

for i=1:deep
    k_x=k_x+pv(1)+pv(1)*skeepF(i);
    k_y=k_y+pv(2)+pv(2)*skeepF(i);
    vShift(i,2)=round ( k_x);
    vShift(i,1)=round ( k_y);
end
 
%if ssx == 1
%    minCoor(1)= max(vShift(:,2))+1;
%else
%    maxCoor(1) = ctot+min(vShift(:,2));
%end

%if ssy == 1
%    minCoor(2)= max(vShift(:,1))+1;
%else
%    maxCoor(2) = rtot+min(vShift(:,1));
%end

end


