function [Dcube,CCD, DATEOBS, MJD, EXPTIME,minCoor, maxCoor,sizeCube] = readDataDdotiAL( listFile,theType)
%Read aligned data for Ddotti
%Usage:    [Dcube,CCD, DATEOBS, MJD, EXPTIME,minCoor, maxCoor, NF, theType  ] = readDataDdotiAL( listFile)
%
%
%
%
%

opt={'Full','Data','Header'};
TF = strcmpi(opt,theType);

if ~TF(1) &&   ~TF(2) &&  ~TF(3) 
     error('Error: You must type  Full|Data|Header... \n\tAboorting ..\n');
end


[nameF,NF]=readList(listFile);

CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);
sizeCube=zeros(1,3);

sizeCube(1)=readHDR(nameF{1}(1,:),'NAXIS2','%d'); % No of rows Y-axis
sizeCube(2)=readHDR(nameF{1}(1,:),'NAXIS1','%d'); % No ofcolumns  X-axis
sizeCube(3)=NF; % The deep

if TF(1) ||  TF(3) 

    for nimg=1:NF
        CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
        DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
        MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
        EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
        theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
        minCoor(nimg,1)=theVal(1);
        minCoor(nimg,2)=theVal(3);
        maxCoor(nimg,1)=theVal(2);
        maxCoor(nimg,2)=theVal(4);
    end
else
    CCD={[]};
    DATEOBS={[]};
    MJD={[]};
    EXPTIME={[]};
    minCoor=[];
    maxCoor=[];
end

if TF(1) ||  TF(2) 
  parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
  end
else
    Dcube=[];
end

end

