function [ scOut ] = rmBias( scCube, biasCube, typeBias)
%Remove the Bias of the Sience Cube
%   Usage:  [ scOut ] = rmBias( scCube, biasCube, typeBias) )
%
%
%
% BH Juky 2021
[row, col, deep]=size(scCube);
scClean=single(zeros(row, col, deep));

opt={'Local','Global'};
TF = strcmpi(opt,typeBias);

if ~TF(1) &&   ~TF(2)
     fprintf("Error: Type of scale mismatch (%s). \n\tWrite Local or Global ... \n\tAborting ..\n", type);
     scOut=[];
     return;
end


%mBiasImg=single(zero(row,col));
if TF(2)
   mBiasVec=masterBias(biasCube);
   mBiasM=repmat(mBiasVec,row,1);
   for img=1:deep
      scClean(:,:,img)=single(scCube(:,:,img))-mBiasM;
   end
else
     for img=1:deep
       mBiasVec=masterBias(biasCube(:,:,img));
       mBiasM=repmat(mBiasVec,row,1);
       scClean(:,:,img)=single(scCube(:,:,img))-mBiasM;
   end
end
  scClean(scClean < 1)=1;
  
  scOut=int16(scClean);

end 

