function [ newCube,mC,sC ] = skyAdjust( theCube, theCenter, theDim )
%SkyAdjust funtions
% Input:
% Cube: data cube only for usuable area
% theCenter[x,y]:  Center of the sky only region
% theDim[w,h];  with,higth of the region
% Output:
% newCube: Data cube corrected 
% mC:   medios of the region frames
% sC; Standar desv   of the region frames

[rtot,ctot,deep]=size(theCube);

newCube=zeros(rtot,ctot,deep);


w=round(theDim(1)/2.);
h=round(theDim(2)/2.);
cx=round(theCenter(1));
cy=round(theCenter(2));

nReg=theCube(cy-h:cy+h, cx-w:cx+w,:);
n2Reg=reshape(nReg,[],deep);
mC=median(n2Reg);
sC=std(n2Reg);

theMean=mean(mC);
theFac=theMean - mC;

for ii=1:deep
    newCube(:,:,ii)=theCube(:,:,ii)+theFac(ii);
end

end

