function [ objVelocityF,...
                    objCentroidF,...
                     objOriginF,...
                    objEccF,...
                    objAreaF, ...
   objBoxF  ] = sumShiftDetect( ...
theCube, ...
pv,...
facStd,...
radius, ...
minBlobArea, ...
maxBlobArea, ...
eccentricity)
%Analize if an asteroid exist due a pixel Velocity in the data cube
%   Usage: [Velocity,Centroid,Origin,Eccen,Area, Box ] = sumShiftDetect( ...
%theCube, ...
%pv,...
%facStd,...
%radius, ...
%minBlobArea, ...
%maxBlobArea, ...
%eccentricity)
%
%
%
%


[rtot,ctot,deep]=size(theCube);

%Compute the shift over the data cube deep
[ vShift, minCoor,maxCoor ] = velPixel( pv,rtot,ctot,deep );

theSumC=zeros(rtot,ctot,deep);
for i=1:deep
    theSumC(:,:,i)=noncircshift(theCube(:,:,i), vShift(i,:));
end
A=sum(theSumC,3);

theS=A(minCoor(2):maxCoor(2),  minCoor(1): maxCoor(1));

A=normalizeData(theS,'log');
a=mean(A(:));
b=std(A(:));
u=a+facStd*b;

B=A>u;
morfR=strel('disk',radius,0);
C=imopen(B,morfR);

theBlob=vision.BlobAnalysis('MinimumBlobArea',minBlobArea,...
    'MaximumBlobArea',maxBlobArea,...
    'EccentricityOutputPort', 1);

[objArea,objCentroid,objBox,objEcc]=step(theBlob,C);

numObj=numel(objArea);
finalObj=0;
for ii=1:numObj
    if (objEcc(ii) <  eccentricity && objEcc(ii) >= 0 )
        finalObj=finalObj+1;
        objAreaF(finalObj)=objArea(ii); 
        objCentroidF(finalObj,:)=objCentroid(ii,:);
        objBoxF(finalObj,:)=objBox(ii,:);
        objEccF(finalObj)=objEcc(ii);
        objOriginF(finalObj)=minCoor;
        objVelocityF(finalObj)=pv;
    end
end



end

