function [ ] = testSumShift (...
    V, ... % V[Vx,Vy] velocity to show
    listFile, ... % txt list
    Data, ... % Data Cube
    type, ... %[List| Cube] List=read list of file;Cube=Use teh Cube 
    ntimes, ... % Clear higth values on data above ntimes
    debug ...
    )


opt={'List','Cube'};

TF = strcmpi(opt,type);

if ~TF(1) &&   ~TF(2)
     fprintf('Error: Type of input data (%s). \n', type);
     fprintf('\tWrite List (for read a list of file ) or Cube (Data are in memory now) \n\tAborting ..\n');
     
     return;
end


tic

[nameF,NF]=readList(listFile);
DATEOBS=cell(NF,1);
EXPTIME=cell(NF,1);
JD=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);
for nimg=1:NF
     DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
     JD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(1);
     minCoor2(nimg,2)=theVal(3);
     maxCoor2(nimg,1)=theVal(2);
     maxCoor2(nimg,2)=theVal(4);
end

if TF(1)
    
  fprintf('\n##################################\n');
  fprintf('Step 1: Read Data Cube and his header info\n');

  parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
  end
  
  for nimg=1:NF
     Data(:,:,nimg)=asteroid_level(Dcube(:,:,nimg),ntimes);
  end
  clear Dcube
  
end







toc



