function [minCoor,maxCoor] = usuableArea(sVec,imgSize)
% Determine the coordinates of the usable area, from a vector that 
% specifies the offset of each image of the data cube.
% ussage: [minC,maxC] = usuableArea(sVec)
% INPUT
%   sVec: Vector of desplacment
%   imgSize: image size (r,c)
% Output:
%   minCoor: Usuable [X_min, Y_min]
%   maxCoor: usuable [X_max, Y_max]
% 
% BHV Nov 2022
%

minCoor=zeros(2,1);
maxCoor=zeros(2,1);

minSx=min(sVec(:,2));
minSy=min(sVec(:,1));
maxSx=max(sVec(:,2));
maxSy=max(sVec(:,1));
Sx=imgSize(2);
Sy=imgSize(1);

minCoor(1)=minSx+abs(maxSx-minSx)+1;
minCoor(2)=minSy+abs(maxSy-minSy)+1;
maxCoor(1)=Sx+maxSx-abs(maxSx-minSx);
maxCoor(2)=Sy+maxSy-abs(maxSy-minSy);

end