function [  ] = wfits(...
    Data, ... % the Image 
    newName, ... %  New  alligned file name with path
    onlyName, ... % previus with out path
    minCoor,...   %  Usuable Area (row,col)
    maxCoor,...   % Usuable Area (row,coll)
    RM, ...             % Rotations Matrix
    TV, ...               % Translation Vector
    deep, ...           % number of deep data Cub
    threshold, ...  %Theshold use for binarize
    theScale, ...     %Image scale user for binarize
    theRadius, ...     % Radius of the circular prototype mask
    theMinArea, ... %Minumim Circular area
    theMaxArea, ... %Maximum Circular area
    theCPoint, ...   %Number of the common control points used
    debug) 
%Write the Data in a fits file format. Also include the header value
%   Detailed explanation goes here A
%
%
%
%
% BH Aug 2021

import matlab.io.*
fitswrite(Data,char(newName));
% first remove the inserted matlab comments
fptr= fits.openFile(char(newName),'readwrite');
fits.writeComment(fptr,'Aligned data cube allgoritms, TAOSII team');
fits.writeComment(fptr,'Authors: BHV/JSS/ESM');
dt=datetime('now');
sdt= sprintf('Date of Run: %s',dt);
fits.writeComment(fptr,sdt);

% New file Name
fits.writeKey(fptr,'ANAME',char(onlyName));

% Usable Area affter allign
% min/max Coor is in Image  Coord that mean
%that axisX is the seconde component (the columns)  and
% the axisY is firts component  (the row) 
%UAREA=[minX:maxX,minY:masY] format
str_uArea=sprintf('[%d:%d,%d:%d]', minCoor(2),maxCoor(2),...
    minCoor(1),maxCoor(1));
fits.writeKey(fptr,'AAREA',str_uArea,'Usuable area');

% Rigid Transformation Rotation Matrix and Trasnlation Vector 
fits.writeKey(fptr,'ACD1_1',double(RM{1}(1,1)),'Rotation matrix');
fits.writeKey(fptr,'ACD1_2',double(RM{1}(1,2)),'Rotation matrix');
fits.writeKey(fptr,'ACD2_1',double(RM{1}(2,1)),'Rotation matrix');
fits.writeKey(fptr,'ACD2_2',double(RM{1}(2,2)),'Rotation matrix');
fits.writeKey(fptr,'ATV1',double(TV{1}(1)),'Translation vector X-axis');
fits.writeKey(fptr,'ATV2',double(TV{1}(2)),'Translation vector Y-axis');

% Parametres of the deteted control points for alligned process
fits.writeKey(fptr,'ADEEP',int32(deep),'Data cube depth');
fits.writeKey(fptr,'ATHRE',double(threshold),'Threshold used to binarize');
fits.writeKey(fptr,'ASCL',char(theScale),'Image scale used LOG|LINEAR');
fits.writeKey(fptr,'ARADIUS',int32(theRadius),'Disk prototype mask radius');
fits.writeKey(fptr,'AMINA',double(theMinArea),'Minumim circular area');
fits.writeKey(fptr,'AMAXA',double(theMaxArea),'Maximum circular area');
fits.writeKey(fptr,'APOINT',int32(theCPoint),'Number of common controls point used');
fits.closeFile(fptr);

if debug
    fitsdisp(char(newName),'mode','full');
end

end

