function [  ] = wfits_ALMask(...
    Data, ... % the Imagee
    newName, ... %  New  alligned file name with path
    onlyName, ... % previous with out path
    minCoor1,...   %  Usuable Area (row,col)
    maxCoor1,...   % Usuable Area (row,col)
    minCoor2,...   %  Usuable Area (row,col)
    maxCoor2,...   % Usuable Area (row,col)
    radiusOfD,... % radus of dilation
    minStars,... % Minumun stars
    maxStars,...  % Maximum stars
    typeFactor, ... % Typ Factor used {backgroud| Std]
    theFact, ...  % Initial Factor
    finalFactor,...% Final Factor
    theVal,...      % Base factor value
    numObj,...   % Number of objects found
     val1, ...       %DATE-OBS
     val2, ...       %MJD
     val3, ...       %CCD_NAME
     val4, ...       %EXPTIME
    debug) 
%Write the Data in a fits file format. Also include the header value
%   Detailed explanation goes here A
%
%
%
%
% BH Aug 2021

import matlab.io.*

[filepath, ~, ~] = fileparts(newName);
if strcmp(filepath,'.') %Grrrrr matlab can not manage the format "./file"
    if exist(char(onlyName),'file') == 2
      fprintf('Warning: the file [%s] exist. I remove it..',char(newName));
      delete(newName);
    end
else
    if exist(char(newName),'file') == 2
        fprintf('Warning: the file [%s] exist. I remove it..',char(newName))'
        delete(newName);
    end
end
    
fitswrite(uint8(Data),char(newName));
% first remove the inserted matlab comments
fptr= fits.openFile(char(newName),'readwrite');
fits.writeComment(fptr,'Aligned data cube allgoritms, TAOSII team');
fits.writeComment(fptr,'Authors: BHV/JSS/ESM');
dt=datetime('now');
sdt= sprintf('Date of Run: %s',dt);
fits.writeComment(fptr,sdt);

% New file Name
fits.writeKey(fptr,'ANAME',char(onlyName),'Add  [BrAL...] postfix');
fits.writeComment(fptr,'Br: Bias removed; AL: Aligned; 2: 2nd aligned; U: usuable area');
fits.writeComment(fptr,'S: Sky background without trend; M: Median removed (without star)');
fits.writeComment(fptr,'P: only stars patch');

% Usable Area affter allign
% min/max Coor is in Image  Coord that mean
%that axisX is the seconde component (the columns)  and
% the axisY is firts component  (the row) 
%UAREA=[minX:maxX,minY:masY] format
str_uArea=sprintf('[%d:%d,%d:%d]', minCoor1(1),maxCoor1(1),...
    minCoor1(2),maxCoor1(2));
fits.writeKey(fptr,'AAREA',str_uArea,'Usuable area 1');

str_uArea=sprintf('[%d:%d,%d:%d]', minCoor2(1),maxCoor2(1),...
    minCoor2(2),maxCoor2(2));
fits.writeKey(fptr,'AAREA2',str_uArea,'Usuable area 2');

% Mask calculation parameters
fits.writeKey(fptr,'ARADIO',single(radiusOfD),'Radio of Dilation');
fits.writeKey(fptr,'AMINS',single(minStars),'Minumun stars number');
fits.writeKey(fptr,'AMAXS',single(maxStars),'Maximum stars number');
fits.writeKey(fptr,'ATYPEF',typeFactor,'Used factor [Background|Std]');
fits.writeKey(fptr,'AFAC1',theFact,'Initial value of the factor');
fits.writeKey(fptr,'AFAC2',finalFactor,'Final value of the factor');
fits.writeKey(fptr,'AFACV',theVal,'Base value of factor');
fits.writeKey(fptr,'AOBJ',single(numObj),'Objects found');

% from original observation
fits.writeKey(fptr,'DATE-OBS',char(val1),'By original file');
fits.writeKey(fptr,'MJD',double(val2),'By original file');
fits.writeKey(fptr,'CCD_NAME',val3,'By original file');
fits.writeKey(fptr,'EXPTIME',single(val4),'By original file');


fits.closeFile(fptr);

if debug
    fitsdisp(char(newName),'mode','full');
end

end

